import tarfile
import os 
import re
import datetime
import ftplib
import sys

username = os.environ['USER']


def ftpbrainsenses(fileinput,password):
  ''' 
  import primateutils as p; import datetime
  a = datetime.datetime.now();nf = p.tarsofts(a)
  p.ftpbrainsenses(nf)
  '''
  username = 'olivier'
  session = ftplib.FTP('ftp.brainsenses.x10host.com','chimay',password) # Connect to the FTP server
  name = fileinput
  cmd = 'STOR /public_html/%s/primatepy/%s' %(username,os.path.basename(name))
  myfile = open(name,'rb')                       # Open the file to send
  print '--> transferring %s to http://brainsenses.x10host.com/%s/primatepy/%s' %(name,username, os.path.basename(name))
  session.storbinary(cmd, myfile)            # Send the file
  myfile.close()
  session.quit()
  print 'done'
  
def tarsofts(a):
  '''
  import primateutils as p; import datetime
  a = datetime.datetime.now();nf = p.tarsofts(a)
  '''
  namefile = '/tmp/PrimatePy_%d_%02d_%02d_%02d_%02d.tar.bz2' % (a.year,a.month, a.day, a.hour, a.minute)
  tar = tarfile.open(namefile,'w:bz2' )
  #allfiles = os.listdir(os.getcwd())
  #rootdir = os.getcwd()
  nn = '/home/%s/uo/' % os.getlogin()
  os.chdir(nn)
  dirn = 'primatepy'
  allfiles = []
  folderCount = 0
  for root, subFolders, files in os.walk(dirn):
    folderCount += len(subFolders)
    for file in files:
        f = os.path.join(root,file)
        #fileSize = fileSize + os.path.getsize(f)
        #print(f)
        if f[-4:]=='.pyc' or f[-1:]=='~':
	  pass
	else:
	  allfiles.append(f)
        
  filterdef = re.compile(".py$", re.IGNORECASE)
  files = filter(filterdef.search, allfiles)
  for name in allfiles:
      tar.add(name)

  tar.close()
  print namefile
  os.chdir(dirn)
  return namefile
  

def untarsofts(fileinput):
  ''' This function takes a archive .bz2 compressed  file and extractall the files into the local directory might be dangerous !
  '''
  dirno = os.path.basename(fileinput).split('.')[0]
  ppath = os.getcwd()
  #os.chdir('..')
  print 'Dirno %s' % dirno
  os.makedirs(dirno, mode=0777)
  os.chdir(dirno)
  tar = tarfile.open(fileinput,'r:bz2' )
  pathX =  os.getcwd() # should define the path to extract the archive
  print 'Path where extractall %s' % pathX
  #tar.extractall(pathX) # should define the path to extract the archive
  #print pathX
  #tar.close()
  os.chdir(ppath)
  
def getlastfromftp(a,password):
  '''This function retreive the last primatepy software but should take as input the password instead of having it saved into the code in plain text
  This could be done with a wget function no need for ftp nor password
  '''
  session = ftplib.FTP('ftp.brainsenses.x10host.com','chimay',password) # Connect to the FTP server
  wd = '/public_html/%s/primatepy' % username
  wd = '/public_html/%s/primatepy' % 'olivier'
  session.cwd(wd)
  lstiles= []
  session.retrlines('LIST',lstiles.append)
  ff=[]
  for f in lstiles:
    ind = f.find('PrimatePy_')
    if ind>0:
      ff.append(f[ind:])

  corectfile = sorted(ff)[-1]
  cmd = 'RETR %s' % corectfile
  print 'The last archive seems : %s' % corectfile 
  localfile = '/tmp/%s' % corectfile
  session.retrbinary(cmd, open(localfile, 'wb').write)
  session.close()
  return localfile